From 0b7381572b131c74051832dc251604e7f77b5a54 Mon Sep 17 00:00:00 2001
From: Tomohiro Kusumi <tkusumi@netbsd.org>
Date: Sat, 26 Dec 2020 01:36:00 +0900
Subject: [PATCH] sys/vfs/hammer2: Add initial multi-volumes support for
 HAMMER2

This commit adds initial multi-volumes support for HAMMER2. Maximum
supported volumes is 64. The feature and implementation is similar to
multi-volumes support in HAMMER1.

1. ondisk changes
=================
This commit bumps volume header version from 1 to 2, and adds four new
volume header fields using reserved fields in version 1. Other ondisk
structures are unchanged.
* "volu_id" - volume id from 0 to 63, where 0 represents root volume.
* "nvolumes" - number of volumes. All volumes have same the same value.
* "total_size" - sum of "volu_size" in volumes. All volumes have the
  same value.
* "volu_loff[HAMMER2_MAX_VOLUMES]" - A 512 bytes table which contains
  start offset of max 64 volumes within "total_size". All volumes have
  the same value.

Version 1 volume header has 0 for above fields, so HAMMER2 internally
treats "nvolumes" as 1, and "total_size" as "volu_size" to be able to
handle version 1 and 2 transparently.

All volumes have 4 headers, but only root volume ones are relevant.
Non-root volume headers have their own unique "volu_id" and "volu_size",
but other fields are unimportant and never used. Non-root volume headers
have sroot blockset[i] whose type is HAMMER2_BREF_TYPE_INVALID. Non-root
volume headers don't have boot/aux area, so freemap area start from
offset 0. Non-root volume headers are readonly and never updated after
creation. This means non-root volumes are just extra storage to extend
fs size and internally make up a single virtual volume whose size is
"total_size".

It currently doesn't automatically upgrade an existing version 1 fs to
version 2. Only newly created fs becomes version 2 for now.

2. volumes layout
=================
Basically similar to HAMMER1. A first block device argument provided for
newfs_hammer2(8) becomes the root volume, and if specified remaining
devices extend "total_size" as non-root volumes. All volumes except for
the last one have 1GiB (freemap level1) aligned "volu_size".

This means each volume's start offset within "total_size" is also 1GiB
(freemap level1) aligned. The start offsets of volumes are stored in
volu_loff[HAMMER2_MAX_VOLUMES]. Each volu_loff[n] (0 <= n < nvolumes)
represents start offset of volume n within "total_size". Unused volumes
have -1 for volu_loff[n].
e.g. If a fs consists of 1 volume, volu_loff[0] has 0 and rests have -1.
e.g. If a fs consists of 3 volumes, x GiB root volume, y GiB volume,
  and z GiB volume, volu_loff[0] has 0, volu_loff[1] has x, volu_loff[2]
  has x+y, and rests have -1.

Low level I/O function in HAMMER2 uses this linear offsets table to
determine a device vnode to use and relative offset within the device
vnode, for a given blockref's "data_off". This is different from HAMMER1
where logical offset had embedded volume id bits (i.e. there were holes
in logical address space). HAMMER2 needs this table to support multi-
volumes without changing current logical offset mechanism.

Unless all volumes are specified and mountable, mount_hammer2(8) fails
like it failed in HAMMER1. This also applies to other userspace commands
which require volumes specification, except for fstyp(8).

3. userspace commands
=====================
Basically same as or similar to HAMMER1.
* newfs_hammer2(8) takes a list of block device paths as argv[].
* mount_hammer2(8) takes block device paths or names in "a:b:c:..."
  format.
* hammer2(8) takes block device paths or names in "a:b:c:..." format for
  directives which require volumes specification. This commit also adds
  "volume-list" directive and an ioctl command HAMMER2IOC_VOLUME_LIST,
  which are similar to the one in HAMMER1.
* fsck_hammer2(8) takes device paths or names in "a:b:c:..." format.
* fstyp(8) takes device paths in "path1:path2:path3:..." format.

4. limitations
==============
* hammer2(8) "info" directive ignores multi-volumes block devices.
* hammer2(8) "growfs" directive doesn't support multi-volumes fs.
* fstyp(8) is unable to find PFS label via -l option if the PFS inode or
  its parent indirect blocks are located beyond root volume.
* hammer2(8) doesn't support "volume-add" and "volume-del" directives
  which existed in HAMMER1, and there is currently no plan to support.
---
 sbin/fsck_hammer2/Makefile         |   2 +-
 sbin/fsck_hammer2/destroy.c        | 104 ++---
 sbin/fsck_hammer2/reconstruct.c    | 110 +++--
 sbin/fsck_hammer2/test.c           | 178 +++-----
 sbin/hammer2/Makefile              |   4 +-
 sbin/hammer2/cmd_debug.c           | 108 +++--
 sbin/hammer2/cmd_info.c            |  22 +-
 sbin/hammer2/cmd_volume.c          | 106 +++++
 sbin/hammer2/hammer2.8             |  11 +-
 sbin/hammer2/hammer2.h             |   1 +
 sbin/hammer2/hammer2_subs.h        |  43 ++
 sbin/hammer2/main.c                |  12 +
 sbin/hammer2/ondisk.c              | 654 ++++++++++++++++++++++++++
 sbin/hammer2/subs.c                |  44 ++
 sbin/mount_hammer2/mount_hammer2.c |   6 +-
 sbin/newfs_hammer2/Makefile        |   2 +-
 sbin/newfs_hammer2/newfs_hammer2.8 |   4 +-
 sbin/newfs_hammer2/newfs_hammer2.c | 322 +++++++------
 sys/conf/files                     |   1 +
 sys/vfs/hammer2/Makefile           |   2 +-
 sys/vfs/hammer2/hammer2.h          |  51 ++-
 sys/vfs/hammer2/hammer2_bulkfree.c |  28 +-
 sys/vfs/hammer2/hammer2_disk.h     |  36 +-
 sys/vfs/hammer2/hammer2_flush.c    |  18 +-
 sys/vfs/hammer2/hammer2_freemap.c  |  12 +-
 sys/vfs/hammer2/hammer2_io.c       |  27 +-
 sys/vfs/hammer2/hammer2_ioctl.c    |  53 +++
 sys/vfs/hammer2/hammer2_ioctl.h    |  22 +
 sys/vfs/hammer2/hammer2_ondisk.c   | 707 +++++++++++++++++++++++++++++
 sys/vfs/hammer2/hammer2_subr.c     |   2 +
 sys/vfs/hammer2/hammer2_vfsops.c   | 346 ++++++--------
 usr.sbin/fstyp/fstyp.c             |   2 +
 usr.sbin/fstyp/fstyp.h             |   2 +
 usr.sbin/fstyp/hammer2.c           | 206 ++++++++-
 34 files changed, 2579 insertions(+), 669 deletions(-)
 create mode 100644 sbin/hammer2/cmd_volume.c
 create mode 100644 sbin/hammer2/ondisk.c
 create mode 100644 sys/vfs/hammer2/hammer2_ondisk.c

diff --git a/sbin/fsck_hammer2/Makefile b/sbin/fsck_hammer2/Makefile
index 03a240ecc7..823908d5cf 100644
--- a/sbin/fsck_hammer2/Makefile
+++ b/sbin/fsck_hammer2/Makefile
@@ -14,6 +14,6 @@ LDFLAGS+=${PRIVATELIB_LDFLAGS}
 .PATH: ${.CURDIR}/../../sys/libkern ${.CURDIR}/../../sys/vfs/hammer2/xxhash
 SRCS+= icrc32.c xxhash.c
 .PATH: ${.CURDIR}/../hammer2
-SRCS+= subs.c
+SRCS+= subs.c ondisk.c
 
 .include <bsd.prog.mk>
diff --git a/sbin/fsck_hammer2/destroy.c b/sbin/fsck_hammer2/destroy.c
index 1d1d0ef2fb..c1e7df38b9 100644
--- a/sbin/fsck_hammer2/destroy.c
+++ b/sbin/fsck_hammer2/destroy.c
@@ -34,8 +34,7 @@
  * SUCH DAMAGE.
  */
 
-// # gcc -Wall -g -I../../sys -I../hammer2
-// ../../sys/libkern/icrc32.c ../hammer2/subs.c ./destroy.c -o destroy
+// # gcc -Wall -g -I../../sys -I../hammer2 ../../sys/libkern/icrc32.c ../hammer2/subs.c ../hammer2/ondisk.c ./destroy.c -o destroy
 
 #include <sys/types.h>
 #include <sys/stat.h>
@@ -53,13 +52,13 @@
 
 #include "hammer2_subs.h"
 
-static int modify_blockref(int, const hammer2_volume_data_t *, int,
+static int modify_blockref(const hammer2_volume_data_t *, int,
     hammer2_blockref_t *, hammer2_blockref_t *);
-static int modify_inode(int, const hammer2_blockref_t *,
+static int modify_inode(const hammer2_blockref_t *,
+    hammer2_media_data_t *, size_t);
+static int modify_dirent_embedded(int, hammer2_blockref_t *);
+static int modify_dirent(int, hammer2_blockref_t *, const hammer2_blockref_t *,
     hammer2_media_data_t *, size_t);
-static int modify_dirent_embedded(int, int, hammer2_blockref_t *);
-static int modify_dirent(int, int, hammer2_blockref_t *,
-    const hammer2_blockref_t *, hammer2_media_data_t *, size_t);
 
 static hammer2_tid_t src_inode = 0;
 static hammer2_tid_t dst_inode = 0;
@@ -68,7 +67,7 @@ static const char *dst_dirent = NULL;
 static bool ForceOpt = false;
 
 static int
-destroy_blockref(int fd, uint8_t type)
+destroy_blockref(uint8_t type)
 {
 	bool failed = false;
 	int i;
@@ -76,23 +75,25 @@ destroy_blockref(int fd, uint8_t type)
 	for (i = 0; i < HAMMER2_NUM_VOLHDRS; ++i) {
 		hammer2_volume_data_t voldata;
 		hammer2_blockref_t broot;
+		hammer2_off_t off;
 		ssize_t ret;
 
 		memset(&broot, 0, sizeof(broot));
 		broot.type = type;
 		broot.data_off = (i * HAMMER2_ZONE_BYTES64) | HAMMER2_PBUFRADIX;
-		if (lseek(fd, broot.data_off & ~HAMMER2_OFF_MASK_RADIX,
-		    SEEK_SET) == -1) {
+		off = broot.data_off & ~HAMMER2_OFF_MASK_RADIX;
+		if (lseek(hammer2_get_root_volume_fd(),
+		    off - hammer2_get_root_volume_offset(), SEEK_SET) == -1) {
 			perror("lseek");
 			return -1;
 		}
 
-		ret = read(fd, &voldata, HAMMER2_PBUFSIZE);
+		ret = read(hammer2_get_root_volume_fd(), &voldata,
+		    HAMMER2_PBUFSIZE);
 		if (ret == HAMMER2_PBUFSIZE) {
 			fprintf(stdout, "zone.%d %016jx\n",
 			    i, (uintmax_t)broot.data_off);
-			if (modify_blockref(fd, &voldata, -1, &broot, NULL)
-			    == -1)
+			if (modify_blockref(&voldata, -1, &broot, NULL) == -1)
 				failed = true;
 		} else if (ret == -1) {
 			perror("read");
@@ -107,12 +108,13 @@ destroy_blockref(int fd, uint8_t type)
 }
 
 static int
-read_media(int fd, const hammer2_blockref_t *bref, hammer2_media_data_t *media,
+read_media(const hammer2_blockref_t *bref, hammer2_media_data_t *media,
     size_t *media_bytes)
 {
 	hammer2_off_t io_off, io_base;
 	size_t bytes, io_bytes, boff;
 	ssize_t ret;
+	int fd;
 
 	bytes = (bref->data_off & HAMMER2_OFF_MASK_RADIX);
 	if (bytes)
@@ -135,7 +137,9 @@ read_media(int fd, const hammer2_blockref_t *bref, hammer2_media_data_t *media,
 		fprintf(stderr, "Bad I/O bytes\n");
 		return -1;
 	}
-	if (lseek(fd, io_base, SEEK_SET) == -1) {
+	fd = hammer2_get_volume_fd(io_off);
+	if (lseek(fd, io_base - hammer2_get_volume_offset(io_base), SEEK_SET)
+	    == -1) {
 		perror("lseek");
 		return -1;
 	}
@@ -154,13 +158,14 @@ read_media(int fd, const hammer2_blockref_t *bref, hammer2_media_data_t *media,
 }
 
 static int
-write_media(int fd, const hammer2_blockref_t *bref,
-    const hammer2_media_data_t *media, size_t media_bytes)
+write_media(const hammer2_blockref_t *bref, const hammer2_media_data_t *media,
+    size_t media_bytes)
 {
 	hammer2_off_t io_off, io_base;
 	char buf[HAMMER2_PBUFSIZE];
 	size_t bytes, io_bytes, boff;
 	ssize_t ret;
+	int fd;
 
 	bytes = (bref->data_off & HAMMER2_OFF_MASK_RADIX);
 	if (bytes)
@@ -180,7 +185,9 @@ write_media(int fd, const hammer2_blockref_t *bref,
 		fprintf(stderr, "Bad I/O bytes\n");
 		return -1;
 	}
-	if (lseek(fd, io_base, SEEK_SET) == -1) {
+	fd = hammer2_get_volume_fd(io_off);
+	if (lseek(fd, io_base - hammer2_get_volume_offset(io_base), SEEK_SET)
+	    == -1) {
 		perror("lseek");
 		return -1;
 	}
@@ -190,7 +197,8 @@ write_media(int fd, const hammer2_blockref_t *bref,
 	}
 
 	memcpy(buf + boff, media, media_bytes);
-	if (lseek(fd, io_base, SEEK_SET) == -1) {
+	if (lseek(fd, io_base - hammer2_get_volume_offset(io_base), SEEK_SET)
+	    == -1) {
 		perror("lseek");
 		return -1;
 	}
@@ -211,7 +219,7 @@ write_media(int fd, const hammer2_blockref_t *bref,
 }
 
 static int
-modify_blockref(int fd, const hammer2_volume_data_t *voldata, int bi,
+modify_blockref(const hammer2_volume_data_t *voldata, int bi,
     hammer2_blockref_t *bref, hammer2_blockref_t *prev_bref)
 {
 	hammer2_media_data_t media;
@@ -219,7 +227,7 @@ modify_blockref(int fd, const hammer2_volume_data_t *voldata, int bi,
 	int i, bcount, namlen;
 	size_t bytes;
 
-	if (read_media(fd, bref, &media, &bytes) == -1)
+	if (read_media(bref, &media, &bytes) == -1)
 		return -1;
 
 	switch (bref->type) {
@@ -232,7 +240,7 @@ modify_blockref(int fd, const hammer2_volume_data_t *voldata, int bi,
 			bcount = 0;
 		}
 		if (src_inode && media.ipdata.meta.inum == src_inode)
-			if (modify_inode(fd, bref, &media, bytes) == -1)
+			if (modify_inode(bref, &media, bytes) == -1)
 				return -1;
 		break;
 	case HAMMER2_BREF_TYPE_INDIRECT:
@@ -246,12 +254,11 @@ modify_blockref(int fd, const hammer2_volume_data_t *voldata, int bi,
 		if (src_dirent && namlen == strlen(src_dirent)) {
 			if (namlen <= sizeof(bref->check.buf) &&
 			    !memcmp(bref->check.buf, src_dirent, namlen)) {
-				if (modify_dirent_embedded(fd, bi, prev_bref)
-				    == -1)
+				if (modify_dirent_embedded(bi, prev_bref) == -1)
 					return -1;
 			} else if (!memcmp(media.buf, src_dirent, namlen)) {
-				if (modify_dirent(fd, bi, prev_bref, bref,
-				    &media, bytes) == -1)
+				if (modify_dirent(bi, prev_bref, bref, &media,
+				    bytes) == -1)
 					return -1;
 			}
 		}
@@ -268,21 +275,20 @@ modify_blockref(int fd, const hammer2_volume_data_t *voldata, int bi,
 
 	for (i = 0; i < bcount; ++i)
 		if (bscan[i].type != HAMMER2_BREF_TYPE_EMPTY)
-			if (modify_blockref(fd, voldata, i, &bscan[i], bref)
-			    == -1)
+			if (modify_blockref(voldata, i, &bscan[i], bref) == -1)
 				return -1;
 	return 0;
 }
 
 static int
-modify_inode(int fd, const hammer2_blockref_t *bref,
+modify_inode(const hammer2_blockref_t *bref,
     hammer2_media_data_t *media, size_t media_bytes)
 {
 	assert(src_inode == media->ipdata.meta.inum);
 
 	if (ForceOpt) {
 		media->ipdata.meta.inum = dst_inode;
-		if (write_media(fd, bref, media, media_bytes) == -1)
+		if (write_media(bref, media, media_bytes) == -1)
 			return -1;
 	}
 
@@ -293,13 +299,13 @@ modify_inode(int fd, const hammer2_blockref_t *bref,
 }
 
 static int
-modify_dirent_embedded(int fd, int bi, hammer2_blockref_t *prev_bref)
+modify_dirent_embedded(int bi, hammer2_blockref_t *prev_bref)
 {
 	hammer2_media_data_t bscan_media;
 	hammer2_blockref_t *bscan;
 	size_t bytes;
 
-	if (read_media(fd, prev_bref, &bscan_media, &bytes) == -1)
+	if (read_media(prev_bref, &bscan_media, &bytes) == -1)
 		return -1;
 	assert(bytes);
 
@@ -329,7 +335,7 @@ modify_dirent_embedded(int fd, int bi, hammer2_blockref_t *prev_bref)
 		bscan->embed.dirent.namlen = strlen(dst_dirent);
 		bscan->key = dirhash((const unsigned char*)dst_dirent,
 		    strlen(dst_dirent));
-		if (write_media(fd, prev_bref, &bscan_media, bytes) == -1)
+		if (write_media(prev_bref, &bscan_media, bytes) == -1)
 			return -1;
 	}
 
@@ -342,7 +348,7 @@ modify_dirent_embedded(int fd, int bi, hammer2_blockref_t *prev_bref)
 }
 
 static int
-modify_dirent(int fd, int bi, hammer2_blockref_t *prev_bref,
+modify_dirent(int bi, hammer2_blockref_t *prev_bref,
     const hammer2_blockref_t *bref, hammer2_media_data_t *media,
     size_t media_bytes)
 {
@@ -351,7 +357,7 @@ modify_dirent(int fd, int bi, hammer2_blockref_t *prev_bref,
 	size_t bytes;
 
 	assert(!memcmp(src_dirent, media->buf, strlen(src_dirent)));
-	if (read_media(fd, prev_bref, &bscan_media, &bytes) == -1)
+	if (read_media(prev_bref, &bscan_media, &bytes) == -1)
 		return -1;
 	assert(bytes);
 
@@ -389,12 +395,12 @@ modify_dirent(int fd, int bi, hammer2_blockref_t *prev_bref,
 		bscan->embed.dirent.namlen = strlen(dst_dirent);
 		bscan->key = dirhash((const unsigned char*)dst_dirent,
 		    strlen(dst_dirent));
-		if (write_media(fd, bref, media, media_bytes) == -1)
+		if (write_media(bref, media, media_bytes) == -1)
 			return -1;
-		if (write_media(fd, prev_bref, &bscan_media, bytes) == -1) {
+		if (write_media(prev_bref, &bscan_media, bytes) == -1) {
 			memset(media->buf, 0, sizeof(media->buf));
 			memcpy(media->buf, src_dirent, strlen(src_dirent));
-			if (write_media(fd, bref, media, media_bytes) == -1)
+			if (write_media(bref, media, media_bytes) == -1)
 				return -1;
 			return -1;
 		}
@@ -472,8 +478,7 @@ init_args(int argc, char **argv, const char **devpathp)
 int
 main(int argc, char **argv)
 {
-	struct stat st;
-	int ch, fd;
+	int ch;
 	const char *binpath = argv[0];
 	const char *devpath;
 
@@ -497,25 +502,12 @@ main(int argc, char **argv)
 	if (init_args(argc, argv, &devpath) == -1)
 		exit(1);
 
-	fd = open(devpath, O_RDWR);
-	if (fd == -1) {
-		perror("open");
-		exit(1);
-	}
-
-	if (fstat(fd, &st) == -1) {
-		perror("fstat");
-		exit(1);
-	}
-	if (!S_ISCHR(st.st_mode) && !S_ISREG(st.st_mode)) {
-		fprintf(stderr, "Unsupported file type\n");
-		exit(1);
-	}
+	hammer2_init_volumes(devpath, 0);
 
-	if (destroy_blockref(fd, HAMMER2_BREF_TYPE_VOLUME) == -1)
+	if (destroy_blockref(HAMMER2_BREF_TYPE_VOLUME) == -1)
 		exit(1);
 
-	close(fd);
+	hammer2_cleanup_volumes();
 
 	return 0;
 }
diff --git a/sbin/fsck_hammer2/reconstruct.c b/sbin/fsck_hammer2/reconstruct.c
index 5a9f595f15..cb9185f161 100644
--- a/sbin/fsck_hammer2/reconstruct.c
+++ b/sbin/fsck_hammer2/reconstruct.c
@@ -34,8 +34,7 @@
  * SUCH DAMAGE.
  */
 
-// # gcc -Wall -g -I../../sys -I../hammer2 ../../sys/vfs/hammer2/xxhash/xxhash.c
-// ../../sys/libkern/icrc32.c ../hammer2/subs.c ./reconstruct.c -o reconstruct
+// # gcc -Wall -g -I../../sys -I../hammer2 ../../sys/vfs/hammer2/xxhash/xxhash.c ../../sys/libkern/icrc32.c ../hammer2/subs.c ../hammer2/ondisk.c ./reconstruct.c -o reconstruct
 
 #include <sys/types.h>
 #include <sys/stat.h>
@@ -54,17 +53,17 @@
 
 #include "hammer2_subs.h"
 
-static int modify_volume_header(int, hammer2_volume_data_t *,
+static int modify_volume_header(hammer2_volume_data_t *,
     const hammer2_blockref_t *);
-static int modify_blockref(int, const hammer2_volume_data_t *, int,
+static int modify_blockref(const hammer2_volume_data_t *, int,
     hammer2_blockref_t *, hammer2_blockref_t *, int);
-static int modify_check(int, int, hammer2_blockref_t *,
-    const hammer2_blockref_t *, hammer2_media_data_t *, size_t, int);
+static int modify_check(int, hammer2_blockref_t *, const hammer2_blockref_t *,
+    hammer2_media_data_t *, size_t, int);
 
 static bool ForceOpt = false;
 
 static int
-reconstruct_volume_header(int fd)
+reconstruct_volume_header(void)
 {
 	bool failed = false;
 	int i;
@@ -72,21 +71,24 @@ reconstruct_volume_header(int fd)
 	for (i = 0; i < HAMMER2_NUM_VOLHDRS; ++i) {
 		hammer2_volume_data_t voldata;
 		hammer2_blockref_t broot;
+		hammer2_off_t off;
 		ssize_t ret;
 
 		memset(&broot, 0, sizeof(broot));
 		broot.data_off = (i * HAMMER2_ZONE_BYTES64) | HAMMER2_PBUFRADIX;
-		if (lseek(fd, broot.data_off & ~HAMMER2_OFF_MASK_RADIX,
-		    SEEK_SET) == -1) {
+		off = broot.data_off & ~HAMMER2_OFF_MASK_RADIX;
+		if (lseek(hammer2_get_root_volume_fd(),
+		    off - hammer2_get_root_volume_offset(), SEEK_SET) == -1) {
 			perror("lseek");
 			return -1;
 		}
 
-		ret = read(fd, &voldata, HAMMER2_PBUFSIZE);
+		ret = read(hammer2_get_root_volume_fd(), &voldata,
+		    HAMMER2_PBUFSIZE);
 		if (ret == HAMMER2_PBUFSIZE) {
 			fprintf(stdout, "zone.%d %016jx\n",
 			    i, (uintmax_t)broot.data_off);
-			if (modify_volume_header(fd, &voldata, &broot) == -1)
+			if (modify_volume_header(&voldata, &broot) == -1)
 				failed = true;
 		} else if (ret == -1) {
 			perror("read");
@@ -101,7 +103,7 @@ reconstruct_volume_header(int fd)
 }
 
 static int
-reconstruct_blockref(int fd, uint8_t type)
+reconstruct_blockref(uint8_t type)
 {
 	bool failed = false;
 	int i;
@@ -109,23 +111,26 @@ reconstruct_blockref(int fd, uint8_t type)
 	for (i = 0; i < HAMMER2_NUM_VOLHDRS; ++i) {
 		hammer2_volume_data_t voldata;
 		hammer2_blockref_t broot;
+		hammer2_off_t off;
 		ssize_t ret;
 
 		memset(&broot, 0, sizeof(broot));
 		broot.type = type;
 		broot.data_off = (i * HAMMER2_ZONE_BYTES64) | HAMMER2_PBUFRADIX;
-		if (lseek(fd, broot.data_off & ~HAMMER2_OFF_MASK_RADIX,
-		    SEEK_SET) == -1) {
+		off = broot.data_off & ~HAMMER2_OFF_MASK_RADIX;
+		if (lseek(hammer2_get_root_volume_fd(),
+		    off - hammer2_get_root_volume_offset(), SEEK_SET) == -1) {
 			perror("lseek");
 			return -1;
 		}
 
-		ret = read(fd, &voldata, HAMMER2_PBUFSIZE);
+		ret = read(hammer2_get_root_volume_fd(), &voldata,
+		    HAMMER2_PBUFSIZE);
 		if (ret == HAMMER2_PBUFSIZE) {
 			fprintf(stdout, "zone.%d %016jx\n",
 			    i, (uintmax_t)broot.data_off);
-			if (modify_blockref(fd, &voldata, -1, &broot, NULL, -1)
-			    == -1)
+			if (modify_blockref(&voldata, -1, &broot, NULL, -1) ==
+			    -1)
 				failed = true;
 		} else if (ret == -1) {
 			perror("read");
@@ -140,7 +145,7 @@ reconstruct_blockref(int fd, uint8_t type)
 }
 
 static int
-modify_volume_header(int fd, hammer2_volume_data_t *voldata,
+modify_volume_header(hammer2_volume_data_t *voldata,
     const hammer2_blockref_t *bref)
 {
 	hammer2_crc32_t crc0, crc1;
@@ -195,8 +200,10 @@ modify_volume_header(int fd, hammer2_volume_data_t *voldata,
 
 	if (found && ForceOpt) {
 		ssize_t ret;
-		if (lseek(fd, bref->data_off & ~HAMMER2_OFF_MASK_RADIX,
-		    SEEK_SET) == -1) {
+		int fd = hammer2_get_root_volume_fd();
+		hammer2_off_t off = bref->data_off & ~HAMMER2_OFF_MASK_RADIX;
+		if (lseek(fd, off - hammer2_get_root_volume_offset(), SEEK_SET)
+		    == -1) {
 			perror("lseek");
 			return -1;
 		}
@@ -218,12 +225,13 @@ modify_volume_header(int fd, hammer2_volume_data_t *voldata,
 }
 
 static int
-read_media(int fd, const hammer2_blockref_t *bref, hammer2_media_data_t *media,
+read_media(const hammer2_blockref_t *bref, hammer2_media_data_t *media,
     size_t *media_bytes)
 {
 	hammer2_off_t io_off, io_base;
 	size_t bytes, io_bytes, boff;
 	ssize_t ret;
+	int fd;
 
 	bytes = (bref->data_off & HAMMER2_OFF_MASK_RADIX);
 	if (bytes)
@@ -246,7 +254,9 @@ read_media(int fd, const hammer2_blockref_t *bref, hammer2_media_data_t *media,
 		fprintf(stderr, "Bad I/O bytes\n");
 		return -1;
 	}
-	if (lseek(fd, io_base, SEEK_SET) == -1) {
+	fd = hammer2_get_volume_fd(io_off);
+	if (lseek(fd, io_base - hammer2_get_volume_offset(io_base), SEEK_SET)
+	    == -1) {
 		perror("lseek");
 		return -1;
 	}
@@ -265,13 +275,14 @@ read_media(int fd, const hammer2_blockref_t *bref, hammer2_media_data_t *media,
 }
 
 static int
-write_media(int fd, const hammer2_blockref_t *bref,
-    const hammer2_media_data_t *media, size_t media_bytes)
+write_media(const hammer2_blockref_t *bref, const hammer2_media_data_t *media,
+    size_t media_bytes)
 {
 	hammer2_off_t io_off, io_base;
 	char buf[HAMMER2_PBUFSIZE];
 	size_t bytes, io_bytes, boff;
 	ssize_t ret;
+	int fd;
 
 	bytes = (bref->data_off & HAMMER2_OFF_MASK_RADIX);
 	if (bytes)
@@ -291,7 +302,9 @@ write_media(int fd, const hammer2_blockref_t *bref,
 		fprintf(stderr, "Bad I/O bytes\n");
 		return -1;
 	}
-	if (lseek(fd, io_base, SEEK_SET) == -1) {
+	fd = hammer2_get_volume_fd(io_off);
+	if (lseek(fd, io_base - hammer2_get_volume_offset(io_base), SEEK_SET)
+	    == -1) {
 		perror("lseek");
 		return -1;
 	}
@@ -301,7 +314,8 @@ write_media(int fd, const hammer2_blockref_t *bref,
 	}
 
 	memcpy(buf + boff, media, media_bytes);
-	if (lseek(fd, io_base, SEEK_SET) == -1) {
+	if (lseek(fd, io_base - hammer2_get_volume_offset(io_base), SEEK_SET)
+	    == -1) {
 		perror("lseek");
 		return -1;
 	}
@@ -322,7 +336,7 @@ write_media(int fd, const hammer2_blockref_t *bref,
 }
 
 static int
-modify_blockref(int fd, const hammer2_volume_data_t *voldata, int bi,
+modify_blockref(const hammer2_volume_data_t *voldata, int bi,
     hammer2_blockref_t *bref, hammer2_blockref_t *prev_bref, int depth)
 {
 	hammer2_media_data_t media;
@@ -330,7 +344,7 @@ modify_blockref(int fd, const hammer2_volume_data_t *voldata, int bi,
 	int i, bcount;
 	size_t bytes;
 
-	if (read_media(fd, bref, &media, &bytes) == -1)
+	if (read_media(bref, &media, &bytes) == -1)
 		return -1;
 
 	if (!bytes)
@@ -370,21 +384,21 @@ modify_blockref(int fd, const hammer2_volume_data_t *voldata, int bi,
 
 	for (i = 0; i < bcount; ++i)
 		if (bscan[i].type != HAMMER2_BREF_TYPE_EMPTY)
-			if (modify_blockref(fd, voldata, i, &bscan[i], bref,
+			if (modify_blockref(voldata, i, &bscan[i], bref,
 			    depth + 1) == -1)
 				return -1;
 
 	if (ForceOpt)
-		if (read_media(fd, bref, &media, &bytes) == -1)
+		if (read_media(bref, &media, &bytes) == -1)
 			return -1;
-	if (modify_check(fd, bi, prev_bref, bref, &media, bytes, depth) == -1)
+	if (modify_check(bi, prev_bref, bref, &media, bytes, depth) == -1)
 		return -1;
 
 	return 0;
 }
 
 static int
-modify_check(int fd, int bi, hammer2_blockref_t *prev_bref,
+modify_check(int bi, hammer2_blockref_t *prev_bref,
     const hammer2_blockref_t *bref, hammer2_media_data_t *media,
     size_t media_bytes, int depth)
 {
@@ -404,7 +418,7 @@ modify_check(int fd, int bi, hammer2_blockref_t *prev_bref,
 
 	if (!prev_bref)
 		return 0;
-	if (read_media(fd, prev_bref, &bscan_media, &bytes) == -1)
+	if (read_media(prev_bref, &bscan_media, &bytes) == -1)
 		return -1;
 	assert(bytes);
 
@@ -484,8 +498,7 @@ modify_check(int fd, int bi, hammer2_blockref_t *prev_bref,
 
 	if (found) {
 		if (ForceOpt) {
-			if (write_media(fd, prev_bref, &bscan_media, bytes)
-			    == -1)
+			if (write_media(prev_bref, &bscan_media, bytes) == -1)
 				return -1;
 		}
 		/* If !ForceOpt, only first bad blockref is printed. */
@@ -502,8 +515,7 @@ modify_check(int fd, int bi, hammer2_blockref_t *prev_bref,
 int
 main(int argc, char **argv)
 {
-	struct stat st;
-	int ch, fd;
+	int ch;
 	const char *binpath = argv[0];
 	const char *devpath;
 
@@ -524,34 +536,20 @@ main(int argc, char **argv)
 		exit(1);
 	}
 	devpath = argv[0];
-
-	fd = open(devpath, O_RDWR);
-	if (fd == -1) {
-		perror("open");
-		exit(1);
-	}
-
-	if (fstat(fd, &st) == -1) {
-		perror("fstat");
-		exit(1);
-	}
-	if (!S_ISCHR(st.st_mode) && !S_ISREG(st.st_mode)) {
-		fprintf(stderr, "Unsupported file type\n");
-		exit(1);
-	}
+	hammer2_init_volumes(devpath, 0);
 
 	printf("freemap\n");
-	if (reconstruct_blockref(fd, HAMMER2_BREF_TYPE_FREEMAP) == -1)
+	if (reconstruct_blockref(HAMMER2_BREF_TYPE_FREEMAP) == -1)
 		exit(1);
 	printf("volume\n");
-	if (reconstruct_blockref(fd, HAMMER2_BREF_TYPE_VOLUME) == -1)
+	if (reconstruct_blockref(HAMMER2_BREF_TYPE_VOLUME) == -1)
 		exit(1);
 
 	printf("volume header\n");
-	if (reconstruct_volume_header(fd) == -1)
+	if (reconstruct_volume_header() == -1)
 		exit(1);
 
-	close(fd);
+	hammer2_cleanup_volumes();
 
 	return 0;
 }
